Subject: bug#9762: closed (Re: bug#9762: tac fails when given multiple non-seekable inputs due to misuse of mkstemp())

From: [email-masked] (GNU bug Tracking System)
Date: Wed, 19 Oct 2011 07:36:02 +0000

Your bug report

#9762: tac fails when given multiple non-seekable inputs due to misuse of mkstemp()

which was filed against the coreutils package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
9762: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=9762
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#9762: tac fails when given multiple non-seekable inputs due to misuse of mkstemp()
From: Jim Meyering <[email-masked]>
To: Ambrose Feinstein <[email-masked]>
Cc: [email-masked]
Date: Wed, 19 Oct 2011 09:34:39 +0200
List-Id: <debbugs-submit.debbugs.gnu.org>

Jim Meyering wrote:
> Ambrose Feinstein wrote:
>> Thanks for the quick fix!
>>
>> Aside from it requiring rearranging other code to not close the fd,
>> was there a reason not to reuse a single temp file?
>
> Actually that's what I started doing, but the change seemed like it'd
> end up being bigger than I wanted for a bug fix.  In retrospect, now
> that I've done it and see the extent, it would have been ok.
>
> Especially once I considered another factor: we want to avoid use of
> functions like xmalloc and file_name_concat that call exit upon failure.
> See the log on the second patch below for why.
>
>
>>>From fef2bc68e36c8891780311d8869db23753c093d0 Mon Sep 17 00:00:00 2001
> From: Jim Meyering <[email-masked]>
> Date: Tue, 18 Oct 2011 11:44:39 +0200
> Subject: [PATCH 1/3] tac: use only one temporary file, with multiple
>  nonseekable inputs
>
> * src/tac.c (temp_stream): New function, factored out of...
> (copy_to_temp): ...here.
> (tac_nonseekable): Don't free or fclose, now that we reuse the file.

Added this, and pushed:

Suggested by Ambrose Feinstein.
* THANKS.in: Update.

diff --git a/THANKS.in b/THANKS.in
index 23ac679..83a7864 100644
--- a/THANKS.in
+++ b/THANKS.in
@@ -37,6 +37,7 @@ Alexandre Duret-Lutz                [email-masked]
 Alexey Solovyov                     [email-masked]
 Alexey Vyskubov                     [email-masked]
 Alfred M. Szmidt                    [email-masked]
+Ambrose Feinstein                   [email-masked]
 Andi Kleen                          [email-masked]
 Andre Novaes Cunha                  [email-masked]
 Andreas Frische                     [email-masked]

Subject: tac fails when given multiple non-seekable inputs due to misuse of mkstemp()
From: Ambrose Feinstein <[email-masked]>
To: [email-masked]
Date: Sat, 15 Oct 2011 13:40:17 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

Trivial reproduction:

$ true | tac - -
tac: cannot create temporary file in `/tmp': Invalid argument

This is present in coreutils 8.14.

The cause is the way "template" is reused in copy_to_temp().  The
"XXXXXX" suffix is clobbered by the first call to mkstemp(), so the
next call returns EINVAL.

It looks like the intent is to call mkstemp() at most once and then
reuse that file; for example, record_or_unlink_tempfile() will delete
at most one file on exit.